#!/bin/bash
# Script: e17install - Install e17 cvs with libs
# Author: Steffen Wirth alias bert2002
# Date: 19.11.05
# www.pissflitsche.net/e17
version=0.8


# Please not that e17 has many depends on other programs, if you have problems to build it, look at: http://get-e.org/E17_User_Guide/Legacy/_pages/2.1.html
# Now it uses the 'minimal' requirements
declare -x eapps="e17/libs/eet e17/libs/evas e17/libs/ecore e17/libs/embryo e17/libs/edje e17/apps/e"


# User config end here, please dont change next lines, if you dont know  what you do :)

function depends {
			for idepends in type cvs dialog make gcc; do
				type $idepends >> /dev/null ; if [ $? == 1 ]; then echo "Checking $idepends ... failed... Please install $idepends " && exit 1 ; else echo "Checking $idepends ... Okay" && sleep 0.2; fi
			done
}

function location {
			mkdir ~/.e17install/ 2> /dev/null
			if [ -e ~/.e17install/.sourcecode ]; then
				echo "Sourcecode: Okay"
			else
				dialog --title "Sourcecode area" --backtitle "e17install $version" --inputbox "Where is the sourcecode from e17?\nDon\`t end with '/'. You can get errors." 10 50 ~/.e17install 2> ~/.e17install/.sourcecode
			
				if [ $? == 0 ]; then
					echo "Sourcecode: Okay"
				else
					rm -rf ~/.e17install/.sourcecode 2> /dev/null
					echo "Cancel by user or Error: `$?`" && exit 1
				fi
			fi
			e17source=`cat ~/.e17install/.sourcecode`
			mkdir -p $e17source 2> /dev/null
			touch $e17source/test 2> /dev/null
			if [ $? == 1 ]; then
				dialog --title "Error" --backtitle "e17install $version" --ok-label "exit" --msgbox "I have no write permission to: $e17source\n Please restart and correct the path." 6 50
				rm -rf ~/.e17install/.sourcecode 2> /dev/null
				exit 1
			else
				echo "Sourcecode read/write: Okay"
			fi
}


function install {
			if [ -e ~/.e17install/.e17path ]; then
				echo "e17 Install Path: Okay"
			else

				if [ `id -un` == root ]; then
					dialog --title "e17 install area" --backtitle "e17install $version" --inputbox "Where I should install e17?\nDon\`t end with '/'. You can get errors." 10 50 /usr/local 2> ~/.e17install/.e17path
						if [ $? == 0 ]; then
							echo "e17 Install Path: Okay"
						else
							rm -rf ~/.e17install/.e17path 2> /dev/null
							echo "Cancel by user or Error: `$?`" && exit 1
						fi

				else
					dialog --title "e17 install area" --backtitle "e17install $version" --inputbox "Where I should install e17?\nDon\`t end with '/'. You can get errors." 10 50 ~/e17 2> ~/.e17install/.e17path
				fi
				if [ $? == 0 ]; then
					echo "e17 Install Path: Okay"
				else
					rm -rf ~/.e17install/.e17path 2> /dev/null
					echo "Cancel by user or Error: `$?`" && exit 1
				fi
			fi
			e17path=`cat ~/.e17install/.e17path`
			mkdir -p $e17path 2> /dev/null
			touch $e17path/test 2> /dev/null
			if [ $? == 1 ]; then
				dialog --title "Error" --backtitle "e17install $version" --ok-label "exit" --msgbox "I have no write permission to: $e17source\n Please restart and correct the path." 6 50
				rm -rf ~/.e17install/.e17path 2> /dev/null
				exit 1
			else
				echo "e17 install path read/write: Okay"
			fi
}


function installer {
			export PATH=$PATH:$e17source:$e17path
			export CPPFLAGS="$CPPFLAGS -I$e17path/include"
			export LDFLAGS="$LDFLAGS -L$e17path/lib"
			dialog --title "Installer" --backtitle "e17install $version" --yesno "Do you want install/update enlightenment 17 now?" 5 55
			if [ $? == 0 ]; then
				cd $e17source
				mkdir -p ./e17/log/ 2> /dev/null
				rm -rf ./e17/log/*.log 2> /dev/null
				for iinstaller in $eapps ; do 
					cd $e17source
					cvs -d:pserver:anonymous:@cvs.sourceforge.net:/cvsroot/enlightenment login || echo "Couldnt login to cvs server" || exit 1
					cvs -z3 -d:pserver:anonymous:@cvs.sourceforge.net:/cvsroot/enlightenment co $iinstaller || cvs -z3 -d:pserver:anonymous:@cvs.sourceforge.net:/cvsroot/enlightenment co $iinstaller || echo "Error to get the source" || exit 1
					cd $iinstaller
						./autogen.sh --libdir=$e17path/lib/ --prefix=$e17path && make 2> $e17source/e17/log/`echo $ilib | cut -d / -f3`.log || fehler=1
						if [ fehler == 1 ] ; then 
							tail -f  $e17source/e17/log/`echo $ilib | cut -d / -f3`.log
							echo "Error to build $e17source/$ilib"
							unset fehler
							exit 1
						fi
					make install && ldconfig 2> /dev/null
				done
						
				cd $e17source/e17/log/ 2> /dev/null
				for ilog in `ls` ; do
					if [ -s $ilog ]; then
						echo ""
					else
						rm $ilog 2> /dev/null
					fi
				done


			else
				dialog --ok-label "Bye" --title "What a bummer" --backtitle "e17install $version" --msgbox "You miss a great program.\nVisit www.pissflitsche.net/e17" 6 40
				exit 1
			fi
}


function final {
			if [ -x $e17path/bin/enlightenment ] ; then
				echo "startx $e17path/bin/enlightenment" > $e17path/bin/e17 && chmod a+x $e17path/bin/e17 2> /dev/null
			else
				dialog --title "Compile Error" --backtitle "e17install $version" --msgbox "Cannot locate enlightenment. Is everything compiled correctly?\nPlease look in $e17source/e17/log/ to find the error" 6 70
				exit 1
			fi
			clear
			dialog  --title "complete" --backtitle "e17install $version" --msgbox "We have installed follow libs: $elib\nand the followed apps: $eapps" 8 80
			dialog --title "Ready to start" --backtitle "e17install $version" --msgbox "An Error Log you can find in: $e17source/e17/log/\nYou can Start enlightenment with '$e17path/e17' in one tty. Please close X before you start e17." 7 75

}

# Now we start all functions in a fine order :)

# to check some depends
depends
# setup or check the source location
location
# to set the install folder
install
# lets check out the cvs and build e17
installer
# the last fine test to check e17 install
final

# EOF
